Index: /events/src/test/java/geniusweb/inform/VotingTest.java
===================================================================
--- /events/src/test/java/geniusweb/inform/VotingTest.java	(revision 26)
+++ /events/src/test/java/geniusweb/inform/VotingTest.java	(revision 26)
@@ -0,0 +1,75 @@
+package geniusweb.inform;
+
+import static org.junit.Assert.assertEquals;
+
+import java.io.IOException;
+import java.util.Arrays;
+import java.util.Collections;
+import java.util.List;
+import java.util.Map;
+
+import org.junit.Test;
+
+import com.fasterxml.jackson.core.JsonParseException;
+import com.fasterxml.jackson.core.JsonProcessingException;
+import com.fasterxml.jackson.databind.JsonMappingException;
+import com.fasterxml.jackson.databind.ObjectMapper;
+
+import geniusweb.actions.Offer;
+import geniusweb.actions.PartyId;
+import geniusweb.issuevalue.Bid;
+import geniusweb.issuevalue.DiscreteValue;
+import tudelft.utilities.junit.GeneralTests;
+
+public class VotingTest extends GeneralTests<Voting> {
+
+	private PartyId party1 = new PartyId("party1");
+	private Bid bid1 = new Bid("iss", new DiscreteValue("val1"));
+	private Bid bid2 = new Bid("iss", new DiscreteValue("val2"));
+
+	private Map<PartyId, Integer> powers1 = Collections.singletonMap(party1, 2);
+	private Map<PartyId, Integer> powers2 = Collections.singletonMap(party1, 3);
+
+	private final Voting voting1 = new Voting(
+			Arrays.asList(new Offer(party1, bid1)), powers1);
+	private final Voting voting1a = new Voting(
+			Arrays.asList(new Offer(party1, bid1)), powers1);
+	private final Voting voting2 = new Voting(
+			Arrays.asList(new Offer(party1, bid2)), powers1);
+	private final Voting voting3 = new Voting(
+			Arrays.asList(new Offer(party1, bid1)), powers2);
+
+	private String asJson = "{\"Voting\":{\"offers\":[{\"offer\":{\"actor\":\"party1\",\"bid\":{\"issuevalues\":{\"iss\":\"val1\"}}}}],\"powers\":{\"party1\":2}}}";
+
+	@Override
+	public List<List<Voting>> getGeneralTestData() {
+		return Arrays.asList(Arrays.asList(voting1, voting1a),
+				Arrays.asList(voting2), Arrays.asList(voting3));
+	}
+
+	@Override
+	public List<String> getGeneralTestStrings() {
+		return Arrays.asList("Voting.*Bid.*iss.*val1.*party1.*2.*",
+				"Voting.*Bid.*iss.*val2.*party1.*2.*",
+				"Voting.*Bid.*iss.*val1.*party1.*3.*");
+	}
+
+	@Test
+	public void testSerialize() throws JsonProcessingException {
+		ObjectMapper jackson = new ObjectMapper();
+
+		String json = jackson.writeValueAsString(voting1);
+		System.out.println(json);
+		assertEquals(asJson, json);
+	}
+
+	@Test
+	public void testDeserialize()
+			throws JsonParseException, JsonMappingException, IOException {
+		ObjectMapper jackson = new ObjectMapper();
+		Inform p = jackson.readValue(asJson, Inform.class);
+		System.out.println(p);
+		assertEquals(voting1, p);
+	}
+
+}
Index: /events/src/test/java/geniusweb/inform/YourTurnTest.java
===================================================================
--- /events/src/test/java/geniusweb/inform/YourTurnTest.java	(revision 26)
+++ /events/src/test/java/geniusweb/inform/YourTurnTest.java	(revision 26)
@@ -0,0 +1,70 @@
+package geniusweb.inform;
+
+import static org.junit.Assert.assertEquals;
+
+import java.io.IOException;
+import java.net.URISyntaxException;
+import java.util.Arrays;
+import java.util.List;
+
+import org.junit.Before;
+import org.junit.Test;
+
+import com.fasterxml.jackson.core.JsonParseException;
+import com.fasterxml.jackson.core.JsonProcessingException;
+import com.fasterxml.jackson.databind.JsonMappingException;
+import com.fasterxml.jackson.databind.ObjectMapper;
+
+import tudelft.utilities.junit.GeneralTests;
+
+public class YourTurnTest extends GeneralTests<YourTurn> {
+
+	private YourTurn yourturn1, yourturn1b;
+
+	private String asJson = "{\"YourTurn\":{}}";
+
+	private YourTurn yourturnb;
+
+	@Before
+	public void before() throws URISyntaxException {
+
+		yourturn1 = new YourTurn();
+		yourturn1b = new YourTurn();
+		yourturnb = new YourTurn() {
+			@Override
+			public int hashCode() {
+				return 2;
+			}
+		};
+	}
+
+	@Override
+	public List<List<YourTurn>> getGeneralTestData() {
+		return Arrays.asList(Arrays.asList(yourturn1, yourturn1b),
+				Arrays.asList(yourturnb));
+	}
+
+	@Override
+	public List<String> getGeneralTestStrings() {
+		return Arrays.asList("YourTurn*", "YourTurn*");
+	}
+
+	@Test
+	public void testSerialize() throws JsonProcessingException {
+		ObjectMapper jackson = new ObjectMapper();
+
+		String json = jackson.writeValueAsString(yourturn1);
+		System.out.println(json);
+		assertEquals(asJson, json);
+	}
+
+	@Test
+	public void testDeserialize()
+			throws JsonParseException, JsonMappingException, IOException {
+		ObjectMapper jackson = new ObjectMapper();
+		YourTurn p = (YourTurn) jackson.readValue(asJson, Inform.class);
+		System.out.println(p);
+		assertEquals(yourturn1, p);
+	}
+
+}
Index: /exampleparties/randomparty/src/main/java/geniusweb/exampleparties/randomparty/RandomParty.java
===================================================================
--- /exampleparties/randomparty/src/main/java/geniusweb/exampleparties/randomparty/RandomParty.java	(revision 25)
+++ /exampleparties/randomparty/src/main/java/geniusweb/exampleparties/randomparty/RandomParty.java	(revision 26)
@@ -5,6 +5,6 @@
 import java.util.Arrays;
 import java.util.HashSet;
-import java.util.List;
 import java.util.Random;
+import java.util.Set;
 import java.util.logging.Level;
 import java.util.stream.Collectors;
@@ -204,8 +204,8 @@
 				: Integer.MAX_VALUE;
 
-		List<Vote> votes = voting.getBids().stream().distinct()
-				.filter(bid -> isGood(bid))
-				.map(bid -> new Vote(me, bid, minpower, maxpower))
-				.collect(Collectors.toList());
+		Set<Vote> votes = voting.getBids().stream().distinct()
+				.filter(offer -> isGood(offer.getBid()))
+				.map(offer -> new Vote(me, offer.getBid(), minpower, maxpower))
+				.collect(Collectors.toSet());
 		return new Votes(me, votes);
 	}
Index: /exampleparties/randomparty/src/test/java/geniusweb/exampleparties/randomparty/RandomPartyTest.java
===================================================================
--- /exampleparties/randomparty/src/test/java/geniusweb/exampleparties/randomparty/RandomPartyTest.java	(revision 25)
+++ /exampleparties/randomparty/src/test/java/geniusweb/exampleparties/randomparty/RandomPartyTest.java	(revision 26)
@@ -224,5 +224,6 @@
 
 		Bid bid = findGoodBid();
-		party.notifyChange(new Voting(Arrays.asList(bid),
+		Offer offer = new Offer(PARTY1, bid);
+		party.notifyChange(new Voting(Arrays.asList(offer),
 				Collections.singletonMap(PARTY1, 1)));
 		assertEquals(1, connection.getActions().size());
@@ -230,5 +231,6 @@
 		assertTrue(action instanceof Votes);
 		assertEquals(1, ((Votes) action).getVotes().size());
-		assertEquals(bid, ((Votes) action).getVotes().get(0).getBid());
+		assertEquals(bid,
+				((Votes) action).getVotes().iterator().next().getBid());
 	}
 
Index: /exampleparties/timedependentparty/src/main/java/geniusweb/exampleparties/timedependentparty/TimeDependentParty.java
===================================================================
--- /exampleparties/timedependentparty/src/main/java/geniusweb/exampleparties/timedependentparty/TimeDependentParty.java	(revision 25)
+++ /exampleparties/timedependentparty/src/main/java/geniusweb/exampleparties/timedependentparty/TimeDependentParty.java	(revision 26)
@@ -7,6 +7,6 @@
 import java.util.Arrays;
 import java.util.HashSet;
-import java.util.List;
 import java.util.Random;
+import java.util.Set;
 import java.util.logging.Level;
 import java.util.stream.Collectors;
@@ -277,8 +277,8 @@
 				: Integer.MAX_VALUE;
 
-		List<Vote> votes = voting.getBids().stream().distinct()
-				.filter(bid -> isGood(bid))
-				.map(bid -> new Vote(me, bid, minpower, maxpower))
-				.collect(Collectors.toList());
+		Set<Vote> votes = voting.getBids().stream().distinct()
+				.filter(offer -> isGood(offer.getBid()))
+				.map(offer -> new Vote(me, offer.getBid(), minpower, maxpower))
+				.collect(Collectors.toSet());
 		return new Votes(me, votes);
 	}
Index: /exampleparties/timedependentparty/src/test/java/geniusweb/exampleparties/timedependentparty/TimeDependentPartyMOPACTest.java
===================================================================
--- /exampleparties/timedependentparty/src/test/java/geniusweb/exampleparties/timedependentparty/TimeDependentPartyMOPACTest.java	(revision 25)
+++ /exampleparties/timedependentparty/src/test/java/geniusweb/exampleparties/timedependentparty/TimeDependentPartyMOPACTest.java	(revision 26)
@@ -13,4 +13,5 @@
 import java.nio.file.Paths;
 import java.util.Arrays;
+import java.util.Collections;
 import java.util.HashMap;
 import java.util.Map;
@@ -135,5 +136,6 @@
 		// this is better than party's firstBid
 
-		party.notifyChange(new Voting(Arrays.asList(bestBid), powers));
+		party.notifyChange(new Voting(
+				Arrays.asList(new Offer(otherparty, bestBid)), powers));
 		assertEquals(2, connection.getActions().size());
 
@@ -142,5 +144,5 @@
 		assertEquals(
 				new Votes(me,
-						Arrays.asList(
+						Collections.singleton(
 								new Vote(me, bestBid, 1, Integer.MAX_VALUE))),
 				lastAction);
@@ -159,5 +161,6 @@
 		// this is better than party's firstBid
 
-		party.notifyChange(new Voting(Arrays.asList(bestBid, bestBid), powers));
+		party.notifyChange(new Voting(Arrays.asList(new Offer(me, bestBid),
+				new Offer(otherparty, bestBid)), powers));
 		assertEquals(2, connection.getActions().size());
 
Index: /party/src/test/java/geniusweb/party/CapabilitiesTest.java
===================================================================
--- /party/src/test/java/geniusweb/party/CapabilitiesTest.java	(revision 25)
+++ /party/src/test/java/geniusweb/party/CapabilitiesTest.java	(revision 26)
@@ -69,3 +69,8 @@
 	}
 
+	@Test
+	public void behaviours() {
+		assertEquals(Sets.newSet("SEB", "SAOP"), capabilities3.getBehaviours());
+	}
+
 }
Index: /protocol/src/main/java/geniusweb/protocol/partyconnection/ProtocolToPartyConnections.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/partyconnection/ProtocolToPartyConnections.java	(revision 25)
+++ /protocol/src/main/java/geniusweb/protocol/partyconnection/ProtocolToPartyConnections.java	(revision 26)
@@ -2,7 +2,9 @@
 
 import java.io.IOException;
+import java.util.HashMap;
 import java.util.Iterator;
 import java.util.LinkedList;
 import java.util.List;
+import java.util.Map;
 import java.util.stream.Collectors;
 import java.util.stream.Stream;
@@ -55,10 +57,18 @@
 	 * 
 	 * @param info the {@link Inform} to broadcast
-	 * @throws IOException if the send fails.
+	 * @return a Map&lt;PartyId, IOException&gt; where possible exceptions for
+	 *         each party are stored. Normally a protocol would kick these
+	 *         parties.
 	 */
-	public void broadcast(Inform info) throws IOException {
+	public Map<PartyId, IOException> broadcast(Inform info) {
+		Map<PartyId, IOException> exceptions = new HashMap<>();
 		for (ProtocolToPartyConn conn : connections) {
-			conn.send(info);
+			try {
+				conn.send(info);
+			} catch (IOException e) {
+				exceptions.put(conn.getParty(), e);
+			}
 		}
+		return exceptions;
 	}
 
Index: /protocol/src/main/java/geniusweb/protocol/session/amop/AMOP.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/session/amop/AMOP.java	(revision 25)
+++ /protocol/src/main/java/geniusweb/protocol/session/amop/AMOP.java	(revision 26)
@@ -312,11 +312,13 @@
 		try {
 			setState(state.with(partyconn.getParty(), action));
-			state.getConnections().broadcast(new ActionDone(action));
-			if (state.isAllPartiesActed()) {
-				endPhase.complete();
-			}
 		} catch (Throwable e) {
 			handleError("failed to handle action " + action,
 					partyconn.getParty(), e);
+		}
+		// we ignore broadcast errors here, may need to be fixed.
+		broadcast(new ActionDone(action));
+
+		if (state.isAllPartiesActed()) {
+			endPhase.complete();
 		}
 
@@ -333,9 +335,8 @@
 			return;
 
-		List<Bid> bids = null;
+		List<Offer> bids = null;
 		if (state.getPhase() == Phase.OFFER) {
 			bids = state.getPhaseActions().values().stream()
-					.map(act -> ((Offer) act).getBid())
-					.collect(Collectors.toList());
+					.map(act -> ((Offer) act)).collect(Collectors.toList());
 		}
 
Index: /protocol/src/main/java/geniusweb/protocol/session/amop/AMOPState.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/session/amop/AMOPState.java	(revision 25)
+++ /protocol/src/main/java/geniusweb/protocol/session/amop/AMOPState.java	(revision 26)
@@ -356,5 +356,6 @@
 					.max(Comparator.comparingInt(bid -> agrees.get(bid).size()))
 					.get();
-			newagreements = newagreements.with(maxbid, agrees.get(maxbid));
+			newagreements = newagreements
+					.with(new Agreements(maxbid, agrees.get(maxbid)));
 			for (PartyId party : agrees.get(maxbid)) {
 				allvotes.remove(party);
Index: /protocol/src/main/java/geniusweb/protocol/session/mopac/MOPAC.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/session/mopac/MOPAC.java	(revision 25)
+++ /protocol/src/main/java/geniusweb/protocol/session/mopac/MOPAC.java	(revision 26)
@@ -4,4 +4,5 @@
 import java.util.Collections;
 import java.util.List;
+import java.util.Map;
 import java.util.Timer;
 import java.util.TimerTask;
@@ -358,13 +359,8 @@
 	 */
 	private void broadcastNegotiators(Inform info) {
-		// System.out.println("broadcasting " + info);
-		for (PartyId party : state.getPhase().getPartyStates()
-				.getNegotiatingParties()) {
-			try {
-				connections.get(party).send(info);
-			} catch (IOException e) {
-				state = state.with(new ProtocolException(
-						"Party seems to have disconnected", party, e));
-			}
+		Map<PartyId, IOException> errs = connections.broadcast(info);
+		for (PartyId pid : errs.keySet()) {
+			state = state.with(new ProtocolException(
+					"Party seems to have disconnected", pid, errs.get(pid)));
 		}
 	}
Index: /protocol/src/main/java/geniusweb/protocol/session/mopac/phase/OfferPhase.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/session/mopac/phase/OfferPhase.java	(revision 25)
+++ /protocol/src/main/java/geniusweb/protocol/session/mopac/phase/OfferPhase.java	(revision 26)
@@ -14,5 +14,4 @@
 import geniusweb.inform.Inform;
 import geniusweb.inform.YourTurn;
-import geniusweb.issuevalue.Bid;
 import geniusweb.protocol.ProtocolException;
 import geniusweb.protocol.session.mopac.PartyStates;
@@ -60,7 +59,7 @@
 	}
 
-	protected List<Bid> getOffers() {
+	protected List<Offer> getOffers() {
 		return partyStates.getActions(Offer.class).stream()
-				.map(offer -> offer.getBid()).collect(Collectors.toList());
+				.collect(Collectors.toList());
 	}
 
Index: /protocol/src/main/java/geniusweb/protocol/session/mopac/phase/VotingPhase.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/session/mopac/phase/VotingPhase.java	(revision 25)
+++ /protocol/src/main/java/geniusweb/protocol/session/mopac/phase/VotingPhase.java	(revision 26)
@@ -10,9 +10,9 @@
 import geniusweb.actions.Action;
 import geniusweb.actions.EndNegotiation;
+import geniusweb.actions.Offer;
 import geniusweb.actions.PartyId;
 import geniusweb.actions.Votes;
 import geniusweb.inform.Inform;
 import geniusweb.inform.Voting;
-import geniusweb.issuevalue.Bid;
 import geniusweb.protocol.ProtocolException;
 import geniusweb.protocol.session.mopac.PartyStates;
@@ -24,8 +24,8 @@
 	 * the offers received in the {@link OfferPhase}
 	 */
-	private final List<Bid> offers;
+	private final List<Offer> offers;
 
 	@JsonCreator
-	protected VotingPhase(@JsonProperty("offers") List<Bid> offers,
+	protected VotingPhase(@JsonProperty("offers") List<Offer> offers,
 			@JsonProperty("partyStates") PartyStates partyStates,
 			@JsonProperty("deadlinems") Long deadlinems,
Index: /protocol/src/main/java/geniusweb/protocol/session/saop/SAOP.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/session/saop/SAOP.java	(revision 25)
+++ /protocol/src/main/java/geniusweb/protocol/session/saop/SAOP.java	(revision 26)
@@ -281,4 +281,5 @@
 						partyconn.getParty());
 			}
+			// FIXME? this ignores possible broadcast errors
 			state.getConnections().broadcast(new ActionDone(action));
 			setState(state.with(partyconn.getParty(), action));
Index: /protocol/src/main/java/geniusweb/protocol/session/saop/SAOPState.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/session/saop/SAOPState.java	(revision 25)
+++ /protocol/src/main/java/geniusweb/protocol/session/saop/SAOPState.java	(revision 26)
@@ -131,5 +131,5 @@
 						&& bid.equals(((Accept) act).getBid()));
 		if (allaccept)
-			agree = agree.with(bid, getParties());
+			agree = agree.with(new Agreements(bid, getParties()));
 		return agree;
 	}
Index: /protocol/src/main/java/geniusweb/protocol/session/shaop/SHAOP.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/session/shaop/SHAOP.java	(revision 25)
+++ /protocol/src/main/java/geniusweb/protocol/session/shaop/SHAOP.java	(revision 26)
@@ -316,4 +316,5 @@
 						"Party acts without having the turn", partyid);
 			setState(state.with(partyconn.getParty(), action));
+			// FIXME? this ignores possible broadcast errors
 			state.connections.broadcast(new ActionDone(action));
 			if (!state.isFinal(System.currentTimeMillis()))
Index: /protocol/src/main/java/geniusweb/protocol/session/shaop/SHAOPState.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/session/shaop/SHAOPState.java	(revision 25)
+++ /protocol/src/main/java/geniusweb/protocol/session/shaop/SHAOPState.java	(revision 26)
@@ -209,5 +209,6 @@
 				continue;
 			if (requiredaccepts == 0 && act instanceof Offer)
-				return agrees.with(((Offer) act).getBid(), getLeaders());
+				return agrees.with(
+						new Agreements(((Offer) act).getBid(), getLeaders()));
 			if (!(act instanceof Accept))
 				return agrees;
Index: /protocol/src/test/java/geniusweb/protocol/session/SessionResultTest.java
===================================================================
--- /protocol/src/test/java/geniusweb/protocol/session/SessionResultTest.java	(revision 25)
+++ /protocol/src/test/java/geniusweb/protocol/session/SessionResultTest.java	(revision 26)
@@ -67,6 +67,6 @@
 		issuevalues1.put(ISSUE1, new DiscreteValue("a"));
 		Bid bid1 = new Bid(issuevalues1);
-		Agreements agreement1 = new Agreements().with(bid1,
-				new HashSet<>(Arrays.asList(PARTY1, PARTY2)));
+		Agreements agreement1 = new Agreements().with(new Agreements(bid1,
+				new HashSet<>(Arrays.asList(PARTY1, PARTY2))));
 
 		// different order but that shouldn't matter
@@ -74,6 +74,6 @@
 		issuevalues2.put(ISSUE1, new DiscreteValue("b"));
 		Bid bid2 = new Bid(issuevalues2);
-		Agreements agreement2 = new Agreements().with(bid2,
-				new HashSet<>(Arrays.asList(PARTY1, PARTY3)));
+		Agreements agreement2 = new Agreements().with(new Agreements(bid2,
+				new HashSet<>(Arrays.asList(PARTY1, PARTY3))));
 
 		Map<PartyId, PartyWithProfile> partiesmap = new HashMap<>();
Index: /protocol/src/test/java/geniusweb/protocol/session/amop/AMOPStateTest.java
===================================================================
--- /protocol/src/test/java/geniusweb/protocol/session/amop/AMOPStateTest.java	(revision 25)
+++ /protocol/src/test/java/geniusweb/protocol/session/amop/AMOPStateTest.java	(revision 26)
@@ -275,6 +275,6 @@
 	@Test
 	public void activePartiesAgreedTest() {
-		Agreements agreements = new Agreements().with(bid1,
-				new HashSet<>(Arrays.asList(party1, party2)));
+		Agreements agreements = new Agreements().with(new Agreements(bid1,
+				new HashSet<>(Arrays.asList(party1, party2))));
 		AMOPState state = new AMOPState(Phase.INIT, actions, connections3,
 				progressrounds, settings, partyprofiles1, agreements,
@@ -376,12 +376,12 @@
 	@Test
 	public void testCollectVotes() {
-		Votes vote1AB = new Votes(party1, Arrays
-				.asList(new Vote(party1, a, 2, 9), new Vote(party1, b, 2, 9)));
-		Votes vote2AB = new Votes(party2, Arrays
-				.asList(new Vote(party2, a, 2, 9), new Vote(party2, b, 2, 9)));
+		Votes vote1AB = new Votes(party1, new HashSet<>(Arrays
+				.asList(new Vote(party1, a, 2, 9), new Vote(party1, b, 2, 9))));
+		Votes vote2AB = new Votes(party2, new HashSet<>(Arrays
+				.asList(new Vote(party2, a, 2, 9), new Vote(party2, b, 2, 9))));
 		Votes vote3C = new Votes(party3,
-				Arrays.asList(new Vote(party3, c, 2, 9)));
-		Votes vote4AC = new Votes(party4, Arrays
-				.asList(new Vote(party4, a, 2, 9), new Vote(party4, c, 2, 9)));
+				Collections.singleton(new Vote(party3, c, 2, 9)));
+		Votes vote4AC = new Votes(party4, new HashSet<>(Arrays
+				.asList(new Vote(party4, a, 2, 9), new Vote(party4, c, 2, 9))));
 		// party 1,2,4 vote for A, party 1,2 vote for B, party 3,4 vote for C.
 		// the biggest vote is P,Q,S
@@ -409,12 +409,12 @@
 	public void testNextPhase() {
 		// copy of above. todo cleanup
-		Votes vote1AB = new Votes(party1, Arrays
-				.asList(new Vote(party1, a, 2, 9), new Vote(party1, b, 2, 9)));
-		Votes vote2AB = new Votes(party2, Arrays
-				.asList(new Vote(party2, a, 2, 9), new Vote(party2, b, 2, 9)));
+		Votes vote1AB = new Votes(party1, new HashSet<>(Arrays
+				.asList(new Vote(party1, a, 2, 9), new Vote(party1, b, 2, 9))));
+		Votes vote2AB = new Votes(party2, new HashSet<>(Arrays
+				.asList(new Vote(party2, a, 2, 9), new Vote(party2, b, 2, 9))));
 		Votes vote3C = new Votes(party3,
-				Arrays.asList(new Vote(party3, c, 2, 9)));
-		Votes vote4AC = new Votes(party4, Arrays
-				.asList(new Vote(party4, a, 2, 9), new Vote(party4, c, 2, 9)));
+				Collections.singleton(new Vote(party3, c, 2, 9)));
+		Votes vote4AC = new Votes(party4, new HashSet<>(Arrays
+				.asList(new Vote(party4, a, 2, 9), new Vote(party4, c, 2, 9))));
 		// party 1,2,4 vote for A, party 1,2 vote for B, party 3,4 vote for C.
 		// the biggest vote is P,Q,S
Index: /protocol/src/test/java/geniusweb/protocol/session/mopac/phase/OfferPhaseTest.java
===================================================================
--- /protocol/src/test/java/geniusweb/protocol/session/mopac/phase/OfferPhaseTest.java	(revision 25)
+++ /protocol/src/test/java/geniusweb/protocol/session/mopac/phase/OfferPhaseTest.java	(revision 26)
@@ -135,6 +135,5 @@
 	@Test(expected = ProtocolException.class)
 	public void checkNotAllowedActionTest() throws ProtocolException {
-		phase.checkAction(party1, new Votes(party2, Collections.emptyList()),
-				1);
+		phase.checkAction(party1, new Votes(party2, Collections.emptySet()), 1);
 	}
 
@@ -241,6 +240,7 @@
 	public void getOffersTest() {
 		assertEquals(Collections.emptyList(), phase.getOffers());
-		List<Bid> offs = phase.with(party1, offer, 1).getOffers();
-		assertEquals(Arrays.asList(bid), offs);
+		List<Offer> offs = phase.with(party1, offer, 1).getOffers();
+		assertEquals(1, offs.size());
+		assertEquals(bid, offs.get(0).getBid());
 	}
 
Index: /protocol/src/test/java/geniusweb/protocol/session/mopac/phase/OptInPhaseTest.java
===================================================================
--- /protocol/src/test/java/geniusweb/protocol/session/mopac/phase/OptInPhaseTest.java	(revision 25)
+++ /protocol/src/test/java/geniusweb/protocol/session/mopac/phase/OptInPhaseTest.java	(revision 26)
@@ -50,5 +50,5 @@
 	private final Bid bid = new Bid("issue", new DiscreteValue("yes"));
 	private final Vote vote = new Vote(party1, bid, 2, 3);
-	private final Votes votes = new Votes(party1, Arrays.asList(vote));
+	private final Votes votes = new Votes(party1, Collections.singleton(vote));
 
 	private final List<Votes> prevVotes = Arrays.asList(votes);
@@ -135,6 +135,5 @@
 	@Test(expected = ProtocolException.class)
 	public void checkNotAllowedActionTest() throws ProtocolException {
-		phase.checkAction(party1, new Votes(party2, Collections.emptyList()),
-				1);
+		phase.checkAction(party1, new Votes(party2, Collections.emptySet()), 1);
 	}
 
@@ -175,5 +174,5 @@
 		// so this is an illegal narrowing of the previous vote
 		Vote newVote = new Vote(party1, bid, 2, 2);
-		Votes newVotes = new Votes(party1, Arrays.asList(newVote));
+		Votes newVotes = new Votes(party1, Collections.singleton(newVote));
 
 		// when(prevPhase.getVotes()).thenReturn(Arrays.asList(votes));
Index: /protocol/src/test/java/geniusweb/protocol/session/mopac/phase/VotingPhaseTest.java
===================================================================
--- /protocol/src/test/java/geniusweb/protocol/session/mopac/phase/VotingPhaseTest.java	(revision 25)
+++ /protocol/src/test/java/geniusweb/protocol/session/mopac/phase/VotingPhaseTest.java	(revision 26)
@@ -16,4 +16,5 @@
 
 import geniusweb.actions.EndNegotiation;
+import geniusweb.actions.Offer;
 import geniusweb.actions.PartyId;
 import geniusweb.actions.Vote;
@@ -50,7 +51,7 @@
 	private final Bid bid = new Bid("issue", new DiscreteValue("yes"));
 	private final Vote vote = new Vote(party1, bid, 2, 3);
-	private final Votes votes = new Votes(party1, Arrays.asList(vote));
+	private final Votes votes = new Votes(party1, Collections.singleton(vote));
 
-	private final List<Bid> prevPhase = Arrays.asList(bid);
+	private final List<Offer> prevPhase = Arrays.asList(new Offer(party1, bid));
 
 	public VotingPhaseTest() {
@@ -101,5 +102,6 @@
 	public void testInform() {
 		// when(prevPhase.getOffers()).thenReturn(Arrays.asList(bid));
-		assertEquals(new Voting(Arrays.asList(bid), powers), phase.getInform());
+		assertEquals(new Voting(Arrays.asList(new Offer(party1, bid)), powers),
+				phase.getInform());
 
 	}
@@ -135,6 +137,5 @@
 	@Test(expected = ProtocolException.class)
 	public void checkNotAllowedActionTest() throws ProtocolException {
-		phase.checkAction(party1, new Votes(party2, Collections.emptyList()),
-				1);
+		phase.checkAction(party1, new Votes(party2, Collections.emptySet()), 1);
 	}
 
Index: /timeline/src/main/java/geniusweb/progress/ProgressTime.java
===================================================================
--- /timeline/src/main/java/geniusweb/progress/ProgressTime.java	(revision 25)
+++ /timeline/src/main/java/geniusweb/progress/ProgressTime.java	(revision 26)
@@ -29,10 +29,4 @@
 	 */
 	private final Long duration;
-
-	@SuppressWarnings("unused") // for deserializer
-	private ProgressTime() {
-		start = null;
-		duration = null;
-	}
 
 	/**
Index: /timeline/src/test/java/geniusweb/deadline/DeadlineTest.java
===================================================================
--- /timeline/src/test/java/geniusweb/deadline/DeadlineTest.java	(revision 25)
+++ /timeline/src/test/java/geniusweb/deadline/DeadlineTest.java	(revision 26)
@@ -80,3 +80,8 @@
 	}
 
+	@Test
+	public void getRounds() {
+		assertEquals((Integer) 11, new DeadlineRounds(11, 20).getRounds());
+	}
+
 }
Index: /timeline/src/test/java/geniusweb/progress/ProgressRoundsTest.java
===================================================================
--- /timeline/src/test/java/geniusweb/progress/ProgressRoundsTest.java	(revision 25)
+++ /timeline/src/test/java/geniusweb/progress/ProgressRoundsTest.java	(revision 26)
@@ -2,4 +2,6 @@
 
 import static org.junit.Assert.assertEquals;
+import static org.junit.Assert.assertFalse;
+import static org.junit.Assert.assertTrue;
 import static org.mockito.Mockito.mock;
 import static org.mockito.Mockito.when;
@@ -24,4 +26,6 @@
 public class ProgressRoundsTest extends GeneralTests<Progress> {
 	private DeadlineRounds deadline = mock(DeadlineRounds.class);
+	private final static Integer TESTROUNDS = 10;
+	private final static long TESTTIME = 10; // milliseconds!
 
 	private final Date date = new Date(999l);
@@ -34,7 +38,10 @@
 	private final Progress deadline5 = new ProgressTime(20l, date);
 	private ProgressRounds progress;
-	private final static Integer TESTROUNDS = 10;
 	private final ObjectMapper jackson = new ObjectMapper();
 	private final String progressstring = "{\"rounds\":{\"duration\":10,\"currentRound\":0,\"endtime\":999}}";
+
+	private final long start = 1234;
+	private final Date end = new Date(start + TESTTIME);
+	private final ProgressRounds pr = new ProgressRounds(TESTROUNDS, 4, end);
 
 	@Before
@@ -105,4 +112,5 @@
 	}
 
+	@SuppressWarnings("unused")
 	@Test(expected = IllegalArgumentException.class)
 	public void testIllegalArg1() {
@@ -110,4 +118,5 @@
 	}
 
+	@SuppressWarnings("unused")
 	@Test(expected = IllegalArgumentException.class)
 	public void testIllegalArg2() {
@@ -115,3 +124,37 @@
 	}
 
+	@Test
+	public void pastDeadline() {
+		assertFalse(pr.isPastDeadline(start));
+		assertTrue(pr.isPastDeadline(start + TESTTIME + 1));
+		assertFalse(pr.isPastDeadline(start + TESTTIME - 1));
+		assertTrue(new ProgressRounds(TESTROUNDS, TESTROUNDS, end)
+				.isPastDeadline(start + TESTTIME + 1));
+	}
+
+	@Test
+	public void terminationTime() {
+		assertEquals(start + TESTTIME, pr.getTerminationTime().getTime());
+	}
+
+	@Test
+	public void get() {
+		// time does not matter for rounds-based deadline
+		assertEquals((Double) 0.4d, pr.get(start));
+		assertEquals((Double) 0.4d, pr.get(start + TESTTIME + 1));
+		assertEquals((Double) 0.4d, pr.get(start + TESTTIME));
+		assertEquals((Double) 0.4d, pr.get(start + TESTTIME / 2));
+		assertEquals((Double) 0.4d, pr.get(start - 10));
+		assertEquals((Double) 0.4d, pr.get(start + TESTTIME + 10));
+
+		assertEquals((Double) 0.1d,
+				new ProgressRounds(TESTROUNDS, 1, end).get(start));
+		assertEquals((Double) 1d,
+				new ProgressRounds(TESTROUNDS, TESTROUNDS, end).get(start));
+	}
+
+	@Test
+	public void totalRounds() {
+		assertEquals((Integer) 10, pr.getTotalRounds());
+	}
 }
Index: /timeline/src/test/java/geniusweb/progress/ProgressTimeTest.java
===================================================================
--- /timeline/src/test/java/geniusweb/progress/ProgressTimeTest.java	(revision 25)
+++ /timeline/src/test/java/geniusweb/progress/ProgressTimeTest.java	(revision 26)
@@ -2,4 +2,6 @@
 
 import static org.junit.Assert.assertEquals;
+import static org.junit.Assert.assertFalse;
+import static org.junit.Assert.assertTrue;
 
 import java.io.IOException;
@@ -16,6 +18,4 @@
 import com.fasterxml.jackson.databind.ObjectMapper;
 
-import geniusweb.progress.Progress;
-import geniusweb.progress.ProgressTime;
 import tudelft.utilities.junit.GeneralTests;
 
@@ -30,4 +30,7 @@
 	private final ObjectMapper jackson = new ObjectMapper();
 	private final String progressstring = "{\"time\":{\"duration\":10,\"start\":0}}";
+
+	private final long start = 1234;
+	private final ProgressTime pr = new ProgressTime(TESTTIME, new Date(start));
 
 	@Override
@@ -83,3 +86,25 @@
 	}
 
+	@Test
+	public void pastDeadline() {
+		assertTrue(pr.isPastDeadline(start + TESTTIME + 1));
+		assertFalse(pr.isPastDeadline(start + TESTTIME - 1));
+
+	}
+
+	@Test
+	public void terminationTime() {
+		assertEquals(start + TESTTIME, pr.getTerminationTime().getTime());
+	}
+
+	@Test
+	public void get() {
+		assertEquals((Double) 0d, pr.get(start));
+		assertEquals((Double) 1d, pr.get(start + TESTTIME));
+		assertEquals((Double) 0.5d, pr.get(start + TESTTIME / 2));
+		assertEquals((Double) 0d, pr.get(start - 10));
+		assertEquals((Double) 1d, pr.get(start + TESTTIME + 10));
+
+	}
+
 }
